using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
	class ColliderDebug : MonoBehaviour
    {
        void Update()
        {
            foreach (Collider2D coller in gameObject.GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(coller); //Instance.AddComponent<ColliderDebug>(); (add this to instances)
            }
        }
    }
    public class Mod
    {
        public static void Main()
        {	
		    CategoryBuilder.Create("[PAF] Playground Armed Forces (PAF)", "PAF.", ModAPI.LoadSprite("PAF/PAF.png"));

			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "<color=green>[PAF] Peoples State Miliia",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Militia.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("1.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "<color=green>[PAF] Army Solider (PAF)",
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "Army.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("2.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "<color=green>[PAF] Army Solider (Camo-PAF)",
                    NameToOrderByOverride = "3",
                    DescriptionOverride = "Army.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("3.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "<color=green>[PAF] Peoples Military Police (PMP)",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "Army.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("4.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=green>[PAF] Standard Black Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("H1.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("H1.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=green>[PAF] Standard Brown Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("H2.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("H2.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=green>[PAF] Standard Green Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("H3.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("H3.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=green>[PAF] Tan Camo Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("H4.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("H4.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=green>[PAF] Green Camo Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("H5.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("H5.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=green>[PAF] Snow Camo Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("H6.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("H6.png", 1f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=blue>[PAF] MP Black Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("MP1.png", 2f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MP1.png", 2f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=blue>[PAF] MP Tan Camo Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("MP2.png", 2f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MP2.png", 2f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "<color=blue>[PAF] MP Green Camo Helmet",
                    NameToOrderByOverride = "10",
                    DescriptionOverride = "Helmet.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("MP3.png", 2f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MP3.png", 2f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "[PAF] PAF-Standard Issue P718 Pistol",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Pistol",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/p1.png", 1f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/p1.png", 1f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.8f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 10f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = false;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "[PAF] P718 Pistol",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Pistol",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/p3.png", 1f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/p3.png", 1f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.9f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 12f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = false;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "[PAF] M138 Liberia",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Automatic Pistol",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/p2.png", 1f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/p2.png", 1f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.8f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 4f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.7f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pistol"),
                NameOverride = "[PAF] Mug43k",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Pistol",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/p4.png", 1f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/p4.png", 1f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 1f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 16f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = false;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Submachine Gun"),
                NameOverride = "[PAF] PAF-Standard Issue L11 Automatic-SMG",
                NameToOrderByOverride = "!",
                DescriptionOverride = "SMG",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/p5.png", 0.7f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/p5.png", 0.7f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.6f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 18f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.2f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                NameOverride = "[PAF] A17 Short-Rifle",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Rifle",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/snip.png", 0.8f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/snip.png", 0.8f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.7f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 14f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = false;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("AK-47"),
                NameOverride = "[PAF] PAF-Standard AMA-74 Rifle",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Rifle",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/1.png", 1f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/1.png", 135f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.95f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 10f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.2f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                NameOverride = "[PAF] Lee16 Assault Rifle",
                NameToOrderByOverride = "!",
                DescriptionOverride = "Rifle",
                CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                ThumbnailOverride = ModAPI.LoadSprite("gun/2.png", 1f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gun/2.png", 135f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.30f, 0.1200f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.95f;
                    customCartridge.StartSpeed *= 0.5f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 10f;
                    customCartridge.ImpactForce *= 0f;
                    firearm.Cartridge = customCartridge;
                    Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                     Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("i dont have a sound lol.mp3"),
                    };

                }
            }
            ); ;
			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Basic Military Webbing",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Webbing.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/1.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Web1.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Web2.png", 1f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Green Military Webbing",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Webbing.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/2.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Webg1.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Webg2.png", 1f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Brown Webbing Belt",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Holster.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/beltb.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/beltb.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

				    }
                }
            );
ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Green Webbing Belt",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Holster.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/beltg.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/beltg.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

				    }
                }
            );
			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Basic Military Backpack",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Backpack.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/3.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backlow1.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backup1.png", 1f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
               ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Green Military Backpack",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Backpack.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/4.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backlow2.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backup2.png", 1f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Green Camouflauged Military Backpack",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Backpack.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/5.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backlow3.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backup3.png", 1f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Tan Camouflauged Military Backpack",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Backpack.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/6.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backlow4.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/Backup4.png", 1f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[PAF] Basic Holster",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Holster.",
                    CategoryOverride = ModAPI.FindCategory("[PAF] Playground Armed Forces (PAF)"),
                    ThumbnailOverride = ModAPI.LoadSprite("armour/belt.png", 1f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armour/belt.png", 1f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "LowerBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

				    }
                }
            );
        }
    }
}

